=== common/CMakeLists.txt ===

include(FindPkgConfig)
if(NOT PKG_CONFIG_FOUND)
	message(FATAL_ERROR "pkg-config not found!" )
endif()

pkg_check_modules(NL3ROUTE REQUIRED IMPORTED_TARGET libnl-route-3.0)

include_directories(
	source
)

link_directories(
	${NL3ROUTE_LIBRARY_DIRS}
)

add_library(
	beegfs-common STATIC
	./source/common/Assert.cpp
	./source/common/toolkit/StorageTk.h
	./source/common/toolkit/RandomReentrant.h
	./source/common/toolkit/FsckTk.cpp
	./source/common/toolkit/HashTk.h
	./source/common/toolkit/UnitTk.h
	./source/common/toolkit/PreallocatedFile.h
	./source/common/toolkit/StringTk.h
	./source/common/toolkit/Time.h
	./source/common/toolkit/DisposalCleaner.h
	./source/common/toolkit/MessagingTk.cpp
	./source/common/toolkit/StringTk.cpp
	./source/common/toolkit/FileDescriptor.h
	./source/common/toolkit/EntryIdTk.h
	./source/common/toolkit/ObjectReferencer.h
	./source/common/toolkit/NamedException.h
	./source/common/toolkit/MapTk.cpp
	./source/common/toolkit/MapTk.h
	./source/common/toolkit/TimeAbs.h
	./source/common/toolkit/BitStore.h
	./source/common/toolkit/MetaStorageTk.h
	./source/common/toolkit/MetadataTk.cpp
	./source/common/toolkit/SessionTk.h
	./source/common/toolkit/BuildTypeTk.h
	./source/common/toolkit/ZipIterator.h
	./source/common/toolkit/HighResolutionStats.h
	./source/common/toolkit/NodesTk.h
	./source/common/toolkit/serialization/Serialization.h
	./source/common/toolkit/serialization/Byteswap.h
	./source/common/toolkit/serialization/SerializeStr.cpp
	./source/common/toolkit/OfflineWaitTimeoutTk.h
	./source/common/toolkit/AcknowledgmentStore.cpp
	./source/common/toolkit/SocketTk.h
	./source/common/toolkit/HashTk.cpp
	./source/common/toolkit/AtomicObjectReferencer.h
	./source/common/toolkit/poll/PollList.cpp
	./source/common/toolkit/poll/PollList.h
	./source/common/toolkit/poll/Pollable.h
	./source/common/toolkit/AcknowledgmentStore.h
	./source/common/toolkit/DisposalCleaner.cpp
	./source/common/toolkit/Time.cpp
	./source/common/toolkit/MinMaxStore.h
	./source/common/toolkit/NodesTk.cpp
	./source/common/toolkit/FsckTk.h
	./source/common/toolkit/UiTk.cpp
	./source/common/toolkit/MessagingTkArgs.h
	./source/common/toolkit/StorageTk.cpp
	./source/common/toolkit/MathTk.h
	./source/common/toolkit/MessagingTk.h
	./source/common/toolkit/TempFileTk.h
	./source/common/toolkit/FDHandle.h
	./source/common/toolkit/ListTk.h
	./source/common/toolkit/LockFD.cpp
	./source/common/toolkit/SocketTk.cpp
	./source/common/toolkit/SynchronizedCounter.h
	./source/common/toolkit/TimeTk.h
	./source/common/toolkit/NetFilter.h
	./source/common/toolkit/Pipe.h
	./source/common/toolkit/UnitTk.cpp
	./source/common/toolkit/BitStore.cpp
	./source/common/toolkit/TimeFine.h
	./source/common/toolkit/EntryIdTk.cpp
	./source/common/toolkit/DebugVariable.h
	./source/common/toolkit/Random.h
	./source/common/toolkit/UiTk.h
	./source/common/toolkit/LockFD.h
	./source/common/toolkit/TimeException.h
	./source/common/toolkit/TempFileTk.cpp
	./source/common/toolkit/MetadataTk.h
	./source/common/toolkit/BuildTypeTk.cpp
	./source/common/toolkit/hash_library/sha256.h
	./source/common/toolkit/hash_library/sha256.cpp
	./source/common/Common.h
	./source/common/benchmark/StorageBench.h
	./source/common/NumericID.h
	./source/common/net/sock/SocketDisconnectException.h
	./source/common/net/sock/Socket.cpp
	./source/common/net/sock/SocketTimeoutException.h
	./source/common/net/sock/RoutingTable.h
	./source/common/net/sock/RoutingTable.cpp
	./source/common/net/sock/RDMASocket.cpp
	./source/common/net/sock/StandardSocket.h
	./source/common/net/sock/SocketException.h
	./source/common/net/sock/Socket.h
	./source/common/net/sock/NetworkInterfaceCard.cpp
	./source/common/net/sock/NetworkInterfaceCard.h
	./source/common/net/sock/StandardSocket.cpp
	./source/common/net/sock/SocketInterruptedPollException.h
	./source/common/net/sock/SocketConnectException.h
	./source/common/net/sock/Channel.h
	./source/common/net/sock/PooledSocket.h
	./source/common/net/sock/RDMASocket.h
	./source/common/net/message/AbstractNetMessageFactory.cpp
	./source/common/net/message/SimpleStringMsg.h
	./source/common/net/message/mon/RequestStorageDataRespMsg.h
	./source/common/net/message/mon/RequestMetaDataMsg.h
	./source/common/net/message/mon/RequestStorageDataMsg.h
	./source/common/net/message/mon/RequestMetaDataRespMsg.h
	./source/common/net/message/SimpleIntStringMsg.h
	./source/common/net/message/AcknowledgeableMsg.h
	./source/common/net/message/NetMessage.h
	./source/common/net/message/control/AuthenticateChannelMsg.h
	./source/common/net/message/control/AckMsg.h
	./source/common/net/message/control/AuthenticateChannelMsgEx.h
	./source/common/net/message/control/AuthenticateChannelMsgEx.cpp
	./source/common/net/message/control/PeerInfoMsgEx.cpp
	./source/common/net/message/control/PeerInfoMsgEx.h
	./source/common/net/message/control/GenericResponseMsg.h
	./source/common/net/message/control/DummyMsg.h
	./source/common/net/message/control/SetChannelDirectMsg.h
	./source/common/net/message/control/PeerInfoMsg.h
	./source/common/net/message/NetMessageLogHelper.h
	./source/common/net/message/SimpleUInt16Msg.h
	./source/common/net/message/session/BumpFileVersionRespMsg.h
	./source/common/net/message/session/RefreshSessionMsg.h
	./source/common/net/message/session/opening/CloseChunkFileMsg.h
	./source/common/net/message/session/opening/OpenFileMsg.h
	./source/common/net/message/session/opening/CloseChunkFileRespMsg.h
	./source/common/net/message/session/opening/CloseFileRespMsg.h
	./source/common/net/message/session/opening/CloseFileMsg.h
	./source/common/net/message/session/opening/OpenFileRespMsg.h
	./source/common/net/message/session/AckNotifyRespMsg.h
	./source/common/net/message/session/AckNotifyMsg.h
	./source/common/net/message/session/rw/WriteLocalFileMsg.h
	./source/common/net/message/session/rw/WriteLocalFileRespMsg.h
	./source/common/net/message/session/rw/ReadLocalFileV2Msg.h
	./source/common/net/message/session/GetFileVersionMsg.h
	./source/common/net/message/session/RefreshSessionRespMsg.h
	./source/common/net/message/session/locking/FLockEntryRespMsg.h
	./source/common/net/message/session/locking/LockGrantedMsg.h
	./source/common/net/message/session/locking/FLockRangeRespMsg.h
	./source/common/net/message/session/locking/FLockRangeMsg.h
	./source/common/net/message/session/locking/FLockEntryMsg.h
	./source/common/net/message/session/locking/FLockAppendRespMsg.h
	./source/common/net/message/session/locking/FLockAppendMsg.h
	./source/common/net/message/session/FSyncLocalFileMsg.h
	./source/common/net/message/session/BumpFileVersionMsg.h
	./source/common/net/message/session/FSyncLocalFileRespMsg.h
	./source/common/net/message/session/GetFileVersionRespMsg.h
	./source/common/net/message/NetMessageTypes.h
	./source/common/net/message/SimpleMsg.h
	./source/common/net/message/SimpleIntMsg.h
	./source/common/net/message/nodes/GetMirrorBuddyGroupsRespMsg.h
	./source/common/net/message/nodes/RegisterTargetRespMsg.h
	./source/common/net/message/nodes/RemoveBuddyGroupRespMsg.h
	./source/common/net/message/nodes/GetTargetStatesMsg.h
	./source/common/net/message/nodes/GetTargetMappingsMsg.h
	./source/common/net/message/nodes/storagepools/RefreshStoragePoolsMsg.h
	./source/common/net/message/nodes/storagepools/RemoveStoragePoolMsg.h
	./source/common/net/message/nodes/storagepools/GetStoragePoolsRespMsg.h
	./source/common/net/message/nodes/storagepools/ModifyStoragePoolRespMsg.h
	./source/common/net/message/nodes/storagepools/GetStoragePoolsMsg.h
	./source/common/net/message/nodes/storagepools/ModifyStoragePoolMsg.h
	./source/common/net/message/nodes/storagepools/AddStoragePoolMsg.h
	./source/common/net/message/nodes/storagepools/RemoveStoragePoolRespMsg.h
	./source/common/net/message/nodes/storagepools/AddStoragePoolRespMsg.h
	./source/common/net/message/nodes/UnmapTargetRespMsg.h
	./source/common/net/message/nodes/GetMirrorBuddyGroupsMsg.h
	./source/common/net/message/nodes/GetTargetMappingsRespMsg.h
	./source/common/net/message/nodes/RemoveBuddyGroupMsg.h
	./source/common/net/message/nodes/GetTargetConsistencyStatesMsg.h
	./source/common/net/message/nodes/RegisterTargetMsg.h
	./source/common/net/message/nodes/PublishCapacitiesMsg.h
	./source/common/net/message/nodes/RefreshCapacityPoolsMsg.h
	./source/common/net/message/nodes/HeartbeatMsg.h
	./source/common/net/message/nodes/GetNodeCapacityPoolsMsg.h
	./source/common/net/message/nodes/UnmapTargetMsg.h
	./source/common/net/message/nodes/StorageBenchControlMsgResp.h
	./source/common/net/message/nodes/GetStatesAndBuddyGroupsMsg.h
	./source/common/net/message/nodes/HeartbeatRequestMsg.h
	./source/common/net/message/nodes/GetTargetConsistencyStatesRespMsg.h
	./source/common/net/message/nodes/SetTargetConsistencyStatesRespMsg.h
	./source/common/net/message/nodes/GenericDebugMsg.h
	./source/common/net/message/nodes/RegisterNodeMsg.h
	./source/common/net/message/nodes/RemoveNodeMsg.h
	./source/common/net/message/nodes/GetStatesAndBuddyGroupsRespMsg.h
	./source/common/net/message/nodes/SetTargetConsistencyStatesMsg.h
	./source/common/net/message/nodes/GenericDebugRespMsg.h
	./source/common/net/message/nodes/SetMirrorBuddyGroupRespMsg.h
	./source/common/net/message/nodes/GetClientStatsMsg.h
	./source/common/net/message/nodes/GetClientStatsRespMsg.h
	./source/common/net/message/nodes/GetNodeCapacityPoolsRespMsg.h
	./source/common/net/message/nodes/MapTargetsRespMsg.h
	./source/common/net/message/nodes/RefreshTargetStatesMsg.h
	./source/common/net/message/nodes/ChangeTargetConsistencyStatesRespMsg.h
	./source/common/net/message/nodes/MapTargetsMsg.h
	./source/common/net/message/nodes/StorageBenchControlMsg.h
	./source/common/net/message/nodes/RemoveNodeRespMsg.h
	./source/common/net/message/nodes/SetMirrorBuddyGroupMsg.h
	./source/common/net/message/nodes/GetNodesMsg.h
	./source/common/net/message/nodes/RegisterNodeRespMsg.h
	./source/common/net/message/nodes/GetTargetStatesRespMsg.h
	./source/common/net/message/nodes/GetNodesRespMsg.h
	./source/common/net/message/nodes/ChangeTargetConsistencyStatesMsg.h
	./source/common/net/message/AbstractNetMessageFactory.h
	./source/common/net/message/storage/TruncLocalFileMsg.h
	./source/common/net/message/storage/moving/MovingFileInsertRespMsg.h
	./source/common/net/message/storage/moving/RenameMsg.h
	./source/common/net/message/storage/moving/MovingDirInsertMsg.h
	./source/common/net/message/storage/moving/MovingFileInsertMsg.h
	./source/common/net/message/storage/moving/MovingDirInsertRespMsg.h
	./source/common/net/message/storage/moving/RenameRespMsg.h
	./source/common/net/message/storage/creating/RmDirMsg.h
	./source/common/net/message/storage/creating/MkFileWithPatternMsg.h
	./source/common/net/message/storage/creating/UnlinkFileRespMsg.h
	./source/common/net/message/storage/creating/MkFileWithPatternRespMsg.h
	./source/common/net/message/storage/creating/HardlinkRespMsg.h
	./source/common/net/message/storage/creating/UnlinkFileMsg.h
	./source/common/net/message/storage/creating/RmChunkPathsRespMsg.h
	./source/common/net/message/storage/creating/MkLocalDirRespMsg.h
	./source/common/net/message/storage/creating/MkFileMsg.h
	./source/common/net/message/storage/creating/MkFileRespMsg.h
	./source/common/net/message/storage/creating/HardlinkMsg.h
	./source/common/net/message/storage/creating/RmChunkPathsMsg.h
	./source/common/net/message/storage/creating/MkDirRespMsg.h
	./source/common/net/message/storage/creating/RmDirEntryMsg.h
	./source/common/net/message/storage/creating/MkLocalDirMsg.h
	./source/common/net/message/storage/creating/RmDirEntryRespMsg.h
	./source/common/net/message/storage/creating/RmDirRespMsg.h
	./source/common/net/message/storage/creating/UnlinkLocalFileMsg.h
	./source/common/net/message/storage/creating/RmLocalDirMsg.h
	./source/common/net/message/storage/creating/MkDirMsg.h
	./source/common/net/message/storage/creating/RmLocalDirRespMsg.h
	./source/common/net/message/storage/creating/UnlinkLocalFileRespMsg.h
