=== debian/changelog ===
beegfs (8.1.0~20250810022543.7+bookworm) unstable; urgency=medium

  [ root ]
  * New Release

  [ jenkins-debian-glue Autobuilder ]
  * SNAPSHOT autobuild for unreleased 8.1.0 via jenkins-debian-glue.

 -- jenkins-debian-glue Autobuilder <jenkins@debdev.disconnected-by-peer.at>  Sun, 10 Aug 2025 04:25:43 +0200

beegfs (0-dev) unstable; urgency=low

  * please see http://www.beegfs.com for changelog

 -- BeeGFS Maintainers <packages@beegfs.com>  Thu, 01 Jan 1970 01:00:00 +0100
