=== debian/control ===
Source: beegfs
Section: misc
Priority: optional
Maintainer: BeeGFS Maintainers <packages@beegfs.com>
Build-Depends: debhelper (>= 12.0.0), lsb-release, build-essential, autoconf, automake, devscripts, librdmacm-dev, libibverbs-dev, kmod,
               dkms (<= 3.0.0) | dh-dkms (>=3.0.0), pkg-config, zlib1g-dev, libnl-3-dev, libnl-route-3-dev, libtool, libattr1-dev,
               xfslibs-dev, default-jdk, libssl-dev, libcurl4-openssl-dev, libblkid-dev, uuid-dev, libnl-3-200, libnl-genl-3-200,
               libnl-route-3-200
Standards-Version: 4.1.4.1



Package: libbeegfs-ib
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: BeeGFS InfiniBand support
 This package contains support libraries for InfiniBand.



Package: beegfs-meta
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: libbeegfs-ib (= ${binary:Version})
Description: BeeGFS metadata server daemon
 The package contains the BeeGFS metadata daemon.



Package: beegfs-storage
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: libbeegfs-ib (= ${binary:Version})
Description: BeeGFS storage server daemon
 This package contains the BeeGFS storage server binaries.



Package: beegfs-mon
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: libbeegfs-ib (= ${binary:Version})
Description: BeeGFS mon daemon
 The package contains the BeeGFS mon daemon.



Package: beegfs-mon-grafana
Architecture: all
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: BeeGFS mon dashboards for Grafana
 This package contains the BeeGFS mon dashboards to display monitoring data in Grafana.
 The default dashboard setup requires both Grafana, and InfluxDB.



Package: beegfs-utils
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: libbeegfs-ib (= ${binary:Version})
Description: BeeGFS utils
 This package contains BeeGFS utilities.



Package: beegfs-utils-dev
Architecture: any
Depends: ${misc:Depends}
Description: BeeGFS utils devel files
 This package contains BeeGFS development files and examples.

Package: beeond
Architecture: all
Depends: ${misc:Depends},
  beegfs-utils (= ${binary:Version}), beegfs-mgmtd (= ${binary:Version}), beegfs-meta (= ${binary:Version}),
  beegfs-storage (= ${binary:Version}),
  beegfs-client (= ${binary:Version}) | beegfs-client-dkms (= ${binary:Version}),
  psmisc
Description: BeeOND
 This package contains BeeOND.



Package: beegfs-client
Architecture: all
Depends: ${misc:Depends}, build-essential
Conflicts: beegfs-client-dkms
Recommends: linux-headers-amd64
Description: BeeGFS client
 This package contains scripts, config and source files to build and
 start beegfs-client.

Package: beegfs-client-dkms
Architecture: all
Depends: ${misc:Depends}, dkms
Conflicts: beegfs-client
Recommends: linux-headers-amd64
Description: BeeGFS client (DKMS version)
 This package contains scripts, config and source files to build and
 start beegfs-client. It uses DKMS to build the kernel module.

Package: beegfs-client-compat
Architecture: all
Description: BeeGFS client compat module, allows one to run two different client versions.
 This package allows one to build and to run a compatibility client
 kernel module on a system that has a newer beegfs-client version
 installed.
Depends: ${misc:Depends}, build-essential

Package: beegfs-client-dev
Architecture: any
Depends: ${misc:Depends}
Description: BeeGFS client development files
 This package contains BeeGFS client development files.
